unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    pb: TPaintBox;
    l_w: TLabel;
    sb_x: TScrollBar;
    b_graph: TButton;
    l_startx: TLabel;
    sb_startx: TScrollBar;
    b_zeichne: TButton;
    m_hist: TMemo;
    b_end: TButton;
    procedure sb_xChange(Sender: TObject);
    procedure b_graphClick(Sender: TObject);
    procedure sb_startxChange(Sender: TObject);
    procedure b_zeichneClick(Sender: TObject);
    procedure b_endClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

var
  v_data: array [0..400] of double;
  v_w:double;
  v_imax:integer;

{$R *.DFM}

procedure TForm1.sb_xChange(Sender: TObject);
begin
  l_w.caption:='w: '+floattostrf(sb_x.position/200,ffFixed,4,3);
  v_w:=sb_x.position/200;
end;

procedure TForm1.b_graphClick(Sender: TObject);
var
  v_run:integer;
  v_w,v_max:double;
begin

  // Berechnen
  v_w:=sb_x.position/200;
  v_max:=0;
  for v_run:=0 to 400 do begin
    v_data[v_run]:=(v_run/100)*(1+v_w-v_w*v_run/100);
    if v_data[v_run]>v_max then v_max:=v_data[v_run];
  end;
  v_imax:=trunc(V_max)+1;
  b_graph.caption:=floattostrf(v_max,ffFixed,4,3);

  // Alles schwarz
  pb.canvas.brush.color:=clblack;
  pb.canvas.fillrect(Rect(0,0,440,440));

  // Koordinatenkreuz zeichnen
  pb.Canvas.Pen.Color:=clgreen;

  // X-Achse
  pb.canvas.MoveTo(10,420);
  pb.canvas.LineTo(430,420);

  pb.canvas.MoveTo(120,415);
  pb.canvas.LineTo(120,425);
  pb.canvas.MoveTo(220,415);
  pb.canvas.LineTo(220,425);
  pb.canvas.MoveTo(320,415);
  pb.canvas.LineTo(320,425);
  pb.canvas.MoveTo(420,415);
  pb.canvas.LineTo(420,425);

  // Y-Achse
  pb.canvas.MoveTo(20,10);
  pb.canvas.LineTo(20,430);

  for v_run:=1 to v_imax do begin
    pb.canvas.MoveTo(15,420-(v_run*400 div v_imax));
    pb.canvas.LineTo(25,420-(v_run*400 div v_imax));
  end;

  // Winkelhalbierenden
  with pb.canvas do begin
    pen.color:=clgray;
    moveto(20,420);
    lineto(420,420-(1600 div v_imax));
  end;


  // Graphen
  with pb.canvas do begin
    pen.color:=clred;
    moveto(20,420);
    for v_run := 1 to 400 do begin
      lineTo(20+v_run,420-(trunc(v_data[v_run]*400) div v_imax));
    end;
  end;

end;

procedure TForm1.sb_startxChange(Sender: TObject);
begin
  l_startx.caption:='x: '+floattostrf(sb_startx.position/100,ffFixed,4,3);
end;

procedure TForm1.b_zeichneClick(Sender: TObject);

  function y(x:double):double;
  begin
    y:=x*(1+v_w-x*v_w)
  end;

  function getsy(y:double):integer;
  begin
    getsy:=420-round(y * (400 div v_imax));
  end;

  function getsx(x:double):integer;
  begin
    getsx:=20+round(x*100);
  end;

type
  dpoint = record
    x,y:double;
  end;

var
  vp_run,vp_run2:integer;
  vp_hist:array [0..1500] of dpoint;
  vp_p: dpoint;
  vp_hit:boolean;
begin
  m_hist.Lines.Clear;
  m_hist.Lines.Add('History');
  vp_hit:=false;

  vp_p.x:=sb_startx.position/100;
  vp_p.y:=0;
  vp_run:=0;
  vp_hist[vp_run]:=vp_p;

  pb.canvas.moveto(getsx(vp_p.x),getsy(vp_p.y));
  pb.canvas.pen.color:=clwhite;

  repeat
    inc(vp_run);
    with pb.canvas do begin
      // Schritt 4
      vp_p.y:=y(vp_p.x);
      lineto(getsx(vp_p.x),getsy(vp_p.y));

      // Punkt in History speichern
      vp_hist[vp_run]:=vp_p;
      m_hist.Lines.Add(inttostr(vp_run)+' x: '+floattostrf(vp_p.x, ffFixed, 6,6)+' y: '+floattostrf(vp_p.y, ffFixed, 6,6));

      // Prfen, ob der Punkt bereits einmal vorgekommen ist
      for vp_run2:= 0 to vp_run-1 do begin
        if (vp_p.x=vp_hist[vp_run2].x)and(vp_p.y=vp_hist[vp_run2].y) then vp_hit:=true;
      end;

      // Schritt 3
      vp_p.x:=vp_p.y;
      lineto(getsx(vp_p.x),getsy(vp_p.y));

    end;
  until (vp_run=1500)or(vp_hit);

  if vp_hit then m_hist.Lines.Add('Wiederholung');
  if vp_run=1500 then m_hist.Lines.Add('Abruch, Ende des Arrays');


end;

procedure TForm1.b_endClick(Sender: TObject);
begin
close;
end;

end.
